// Demo created by: Attila Szab
//                  aszabo@sednet.hu

#include "inkey.ch"
#include "box.ch"

// ----------------------------------------------------------------------------

FUNCTION Main()

   local oMouse := MouseNew()
   local lFin := .F.
   local nTop, nLeft, nBottom, nRight
   local cOldColor := SetColor( "W+/B" )

   set cursor off
   cls

   oMouse:Off()
   // Init screen
   @ 0, 0 say space( maxcol() + 1 ) color 'B/W'
   @ 1, 0 say space( maxcol() + 1 ) color 'B/W'
   @ 0, 1 say padc( 'Demonstration of oMouse class for CLIPPER 5.x, ' + ;
    'press ESC when finish', maxcol() + 1 ) color 'B/W'
   @ 1, 1 say padc( 'You can move with the mouse only in the area of ' + ;
    '(2, 0, 22, 79)', maxcol() + 1 ) color 'B/W'
   @ maxrow() - 1 , 0   say space( MaxCol() + 1 ) COLOR "B/W"
   @ maxrow()     , 0   say space( MaxCol() + 1 ) COLOR "B/W"
   @ maxrow() - 1 , 1   say 'You have a mouse: ' + ;
    oMouse:cType + '; version nr. ' + oMouse:cVersion + '; at IRQ ' + ;
    str( oMouse:nIrq, 1, 0 ) color "B/W"
   @ MaxRow()     , 1   say "The mouse is now at row    and col" color "B/W"
   @ MaxRow() - 4 , 71, maxRow() - 2, 78 BOX B_DOUBLE
   @ MaxRow() - 3, 73   say "Exit"

   // Init mouse
   oMouse:On()
   oMouse:SetArea( 2, 0, maxrow() - 2, maxcol() )
   oMouse:SetPos( maxrow() / 2, maxcol() / 2 )

   // Main loop
   do while !lFin

      oMouse:Update()
      if inkey() = K_ESC
         lFin = .T.
      endif

      @ maxrow(), 25 say transform( oMouse:nRow, "99" ) color "B/W"
      @ maxrow(), 36 say transform( oMouse:nCol, "99" ) color "B/W"

      if oMouse:lLeft
         @ maxrow(), 60 say "Left" color "GR+/W"
      else
         @ maxrow(), 60 say "    " color "B/W"
      endif

      if oMouse:lCenter
         @ maxrow(), 65 say "Center" color "GR+/W"
      else
         @ maxrow(), 65 say "      " color "B/W"
      endif

      if oMouse:lRight
         @ maxrow(), 72 say "Right" color "GR+/W"
      else
         @ maxrow(), 72 say "     " color "B/W"
      endif

      // Exit button
      if oMouse:lLeft .and. oMouse:lAt( maxrow() - 4, 71, maxrow() - 2, 78 )
         lFin = .T.
      endif

   enddo

   oMouse:Off()
   setcolor( cOldColor )
   cls

   ?? "What do you think about it? see TEST.PRG to enjoy..."
   ? "Source code available to registered users only"
   ?
   ? "Write to:"
   ?
   ? "          Attila Szab"
   ? "          HU-8200 Veszprm"
   ? "          Berkenye kz 2/B"
   ? "          HUNGARY"
   ?
   ? "Send $15"
   ?
   ? "Also: contact at aszab@sednet.hu tel: +36-88-424-030"
   ?

RETURN NIL

// ----------------------------------------------------------------------------
